<?php

  class pz_data_sources_xml extends pz_data
  {

    var $status;
    var $source;
    var $groupe;
    var $licence;
    var $sources;

    function source_xml_content($id, $params = array())
    { $env = $this->env();
      $content = false;
      $this->status = isset($this->status) ? $this->status : $this->source_status();
      if($this->status !== false)
      { $this->source = isset($params["source"]) ? $params["source"] : $this->source($id);
        if($this->source !== false)
        { $this->groupe = isset($params["groupe"]) ? $params["groupe"] : $this->groupe($this->source["id_groupe"]);
          if($this->groupe !== false)
          { $this->licence = isset($params["licence"]) ? $params["licence"] : $this->licence($this->source["licence"]);
            if($this->licence !== false)
            { if(($this->sources = $this->source_compositions(array("id_composition" => $id))) !== false)
              { $content =
                 "<source>\n"
                ."  <titre><![CDATA[".$this->source["nom"]."]]></titre>\n"
                ."  <auteur><![CDATA[".$this->groupe["nom"]."]]></auteur>\n"
                ."  <from><![CDATA[http://".$_SERVER["SERVER_NAME"].$env->url("sources/view/".$this->status[$this->source["status"]]["nom"], array("id" => $id))."]]></from>\n";
                foreach($this->source["documents"] as $id_document => $document)
                { $content .=
                   "  <document>\n"
                  ."    <nom><![CDATA[".$document["nom"]."]]></nom>\n"
                  ."    <url><![CDATA[".$document["url"]."]]></url>\n"
                  ."  </document>\n";
                }
                if($this->licence != 0)
                { $content .=
                   "  <licence url=\"".$this->licence["url"]."\"><![CDATA[".$this->licence["nom"]."]]></licence>\n";
                }
                if(isset($this->sources[$id]))
                { foreach($this->sources[$id] as $id_source)
                  { $content .=
                     "  <source src=\"http://"
                    .$_SERVER["SERVER_NAME"].$env->path("web").$env->path("content")."sources/".$id_source.".xml"
                    ."\" />\n";
                  }
                }
                $content .=
                 "</source>";
              }
            }
          }
        }
      }
      return $content;
    }

    function set_source_xml($id, $params = array())
    { $env = $this->env();
      $OK = false;
      if(strlen($id) > 0 && ($fh = @fopen($env->path("content")."sources/".$id.".xml", "wb")) !== false)
      { if(($content = $this->source_xml_content($id, $params)) !== false)
        { if(@fwrite($fh, $content)) $OK = true;
        }
        @fclose($fh);
      }
      return $OK;
    }

    function del_source_xml($id)
    { $env = $this->env();
      if(file_exists($env->path("content")."sources/".$id.".xml"))
      { return @unlink($env->path("content")."sources/".$id.".xml");
      }
      return true;
    }

    function maj_source_xml_groupe($groupe)
    { $OK = true;
      if($groupe !== false)
      { $sgbd = $this->sgbd();
        $env = $this->env();
        if($rst = $sgbd->open_data("sources"))
        { while($source = $sgbd->fetch_data($rst))
          { if(isset($source))
            { if($source["id_groupe"] == $groupe["id"])
              { if(!$this->set_source_xml($source["id"], array("source" => $source, "groupe" => $groupe)))
                { $OK = false;
                  break;
                }
              }
            }
            else
            { $OK = false;
              break;
            }
          }
          $sgbd->close_data($rst);
        }
        else $OK = false;
      }
      else $OK = false;
      return $OK;
    }

    function maj_source_xml_licence($licence)
    { $OK = true;
      if($licence !== false)
      { $sgbd = $this->sgbd();
        $env = $this->env();
        if($rst = $sgbd->open_data("sources"))
        { while($source = $sgbd->fetch_data($rst))
          { if(isset($source))
            { if($source["licence"] == $licence["id"])
              { if(!$this->set_source_xml($source["id"], array("source" => $source, "licence" => $licence)))
                { $OK = false;
                  break;
                }
              }
            }
            else
            { $OK = false;
              break;
            }
          }
          $sgbd->close_data($rst);
        }
        else $OK = false;
      }
      else $OK = false;
      return $OK;
    }

  }

?>